function [] = buttonCopyFloatOffsets(~, ~)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

global artoaWorkspace artoaGui;

%% Save Applied state
artoa.controller.edit.offsets.saveAppliedState();

%% Get selected index
index = artoaGui.editOffsets.comboboxFloatOffsetToApplied.Value;

%% Copy selected offset columns to Applied columns
appliedOffsetColumn = 'AppliedOffset';
appliedDriftColumn = 'AppliedDrift';
appliedSoundspeedColumn = 'AppliedSoundspeed';

switch artoaGui.editOffsets.comboboxFloatOffsetToApplied.String{index}
    case 'Measured'
        offsetColumn = 'OffsetStart';
        driftColumn = 'Drift';
        soundspeedColumn = 'MeasuredSoundspeed';
    case 'Empirical'
        offsetColumn = 'EmpiricalOffset';
        driftColumn = 'EmpiricalDrift';
        soundspeedColumn = 'EmpiricalSoundspeed';
    case 'Optimum'
        offsetColumn = 'OptimumTotalOffset';
        driftColumn = 'OptimumTotalDrift';
        soundspeedColumn = 'OptimumSoundspeed';
end

artoaWorkspace.editOffsets.offsets{1, appliedOffsetColumn} = ...
    artoaWorkspace.editOffsets.offsets{1, offsetColumn};
artoaWorkspace.editOffsets.offsets{1, appliedDriftColumn} = ...
    artoaWorkspace.editOffsets.offsets{1, driftColumn};
artoaWorkspace.editOffsets.offsets{1, appliedSoundspeedColumn} = ...
    artoaWorkspace.editOffsets.offsets{1, soundspeedColumn};

%% Update GUI
artoa.controller.edit.offsets.updateGui();

%% Recalculate
artoa.controller.edit.recalculateToaGpsAndPlot();

end

