function [S,off] = read_sensors(S, i, off)

% Read optinal data from additional sensors
%
%

% Optimare Sensorsysteme, 26.10.2010 M.Busack

o2type = 3830;
%o2type = 4330;

% Format
%sen = uint8(S.uD(off));
%off = off + 2;
sen = uint8(S.DS4_FORMAT(i));

% O2 Optode data
if bitget(sen,2) == 1
    if o2type == 4330
        % 4330 Optode
        S.DS4_O2CONC(i) = (S.uD(off+3)*16777216 + S.uD(off+2)*65536 + S.uD(off+1)*256 + S.uD(off)) / 1000;
        S.DS4_O2SATU(i) = (S.uD(off+7)*16777216 + S.uD(off+6)*65536 + S.uD(off+5)*256 + S.uD(off+4)) / 1000;
        S.DS4_O2TEMP(i) = (S.uD(off+11)*16777216 + S.uD(off+10)*65536 + S.uD(off+9)*256 + S.uD(off+8)) / 1000;
        S.DS4_O2CALP(i) = (S.uD(off+15)*16777216 + S.uD(off+14)*65536 + S.uD(off+13)*256 + S.uD(off+12)) / 1000;
        S.DS4_O2TCP(i) = (S.uD(off+19)*16777216 + S.uD(off+18)*65536 + S.uD(off+17)*256 + S.uD(off+16)) / 1000;
        off = off + 20;
        %disp(['Read_sensors offset ',num2str(off)]);
    end
    if o2type == 3830
        % 3830 Optode
        S.DS4_O2CONC(i) = ( (S.uD(off+1)*256 + S.uD(off)) / 100 ) - 10;
        S.DS4_O2SATU(i) = ( (S.uD(off+3)*256 + S.uD(off+2)) / 100 ) - 10;
        S.DS4_O2TEMP(i) = ( (S.uD(off+5)*256 + S.uD(off+4)) / 100 ) - 10;
        off = off + 6;
        if bitget(sen,1) == 1
            % Raw data format
            S.DS4_O2DPHASE(i) = (S.uD(off+1)*256 + S.uD(off)) / 100;
            S.DS4_O2BPHASE(i) = (S.uD(off+3)*256 + S.uD(off+2)) / 100;
            S.DS4_O2RPHASE(i) = (S.uD(off+5)*256 + S.uD(off+4)) / 100;
            S.DS4_O2BAMP(i) = (S.uD(off+9)*16777216 + S.uD(off+8)*65536 + S.uD(off+7)*256 + S.uD(off+6)) / 10;
            S.DS4_O2BPOT(i) = (S.uD(off+11)*256 + S.uD(off+10)) / 100;
            S.DS4_O2RAMP(i) = (S.uD(off+15)*16777216 + S.uD(off+14)*65536 + S.uD(off+13)*256 + S.uD(off+12)) / 10;
            S.DS4_O2RAWTEMP(i) = (S.sD(off+19)*16777216 + S.uD(off+18)*65536 + S.uD(off+17)*256 + S.uD(off+16)) / 100;
            off = off + 20;
        end
    end
end


% CO2 sensor data
if bitget(sen,3) == 1
    dt = [S.uD(off)+2000,S.uD(off+1),S.uD(off+2),S.uD(off+3),S.uD(off+4),S.uD(off+5)];
    %S.DS4_CO2DATETIME(i) = datestr(dt);
    S.DS4_CO2DATETIME(i) = datenum(dt);
    S.DS4_CO2PNDIR(i) = S.uD(off+9)*16777216 + S.uD(off+8)*65536 + S.uD(off+7)*256 + S.uD(off+6);
    S.DS4_CO2PIN(i) = S.uD(off+13)*16777216 + S.uD(off+12)*65536 + S.uD(off+11)*256 + S.uD(off+10);
    S.DS4_CO2SRAW(i) = S.uD(off+15)*256 + S.uD(off+14);
    S.DS4_CO2SREF(i) = S.uD(off+17)*256 + S.uD(off+16);
    S.DS4_CO2TSEN(i) = S.uD(off+19)*256 + S.uD(off+18);
    S.DS4_CO2PCO2(i) = S.sD(off+23)*16777216 + S.uD(off+22)*65536 + S.uD(off+21)*256 + S.uD(off+20);
    S.DS4_CO2TCTRL(i) = S.uD(off+25)*256 + S.uD(off+24);
    S.DS4_CO2TGAS(i) = S.uD(off+27)*256 + S.uD(off+26);
    S.DS4_CO2RHGAS(i) = S.uD(off+31)*16777216 + S.uD(off+30)*65536 + S.uD(off+29)*256 + S.uD(off+28);
    off = off + 32;
end


% Lightsensor data
if bitget(sen,4) == 1
    S.DS4_LICH1(i) = S.uD(off+1)*256 + S.uD(off);
    S.DS4_LICH2(i) = S.uD(off+3)*256 + S.uD(off+2);
    S.DS4_LICH3(i) = S.uD(off+5)*256 + S.uD(off+4);
    off = off + 6;
end

